package alatar.components
{
    import mx.controls.Image;
    
    import spark.components.Button;
    import spark.components.Group;
    
    public class IconButton extends Button
    {
        [SkinPart(required="false")]
        public var iconGroup:Group;
        
        protected var iconImage:Image;
        
        public function IconButton()
        {
            super();
        }
        
        private var _icon:Object;
        
        public function get icon():Object
        {
            return _icon;
        }
        
        public function set icon(value:Object):void
        {
            if (_icon == value)
                return;
            
            _icon = value;
            
            if (!iconImage)
            {
                iconImage = new Image();
            }
            
            iconImage.source = _icon;
            
            if (iconGroup && !iconGroup.contains(iconImage))
            {
                iconGroup.addElement(iconImage);
            }
        }
        
        override protected function partAdded(partName:String, instance:Object):void
        {
            super.partAdded(partName, instance);
            
            if (instance == iconGroup && iconImage)
                iconGroup.addElement(iconImage);
        }
        
        override protected function partRemoved(partName:String, instance:Object):void
        {
            super.partRemoved(partName, instance);
            
            if (instance == iconGroup)
                iconGroup.removeAllElements();
        }
    }
}